## kid3 3.8.2

=== CMakeLists.txt ===
# Build Kid3 using CMake
#
# Linux:
# cmake -DCMAKE_BUILD_TYPE=Release -DWITH_APPS=Qt -DCMAKE_INSTALL_PREFIX=/usr ../kid3
# make
# make install/strip DESTDIR=$(pwd)/inst # or
# cpack
#
# Windows:
# set INCLUDE=%MSYSDIR%\local\include
# set LIB=%MSYSDIR%\local\lib
# cmake -G "MinGW Makefiles" -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX= ..\kid3
# mingw32-make
# cpack
#
# Mac OS X:
# cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX= ../kid3
# make
# cpack

project(kid3)

cmake_minimum_required(VERSION 3.3)

set(BUILD_SHARED_LIBS ON CACHE BOOL "build shared libraries")
set(WITH_QML    ON CACHE BOOL "build with QML")
set(WITH_TAGLIB ON CACHE BOOL "build with TagLib")
set(WITH_MP4V2 OFF CACHE BOOL "build with mp4v2")
set(WITH_FFMPEG OFF CACHE BOOL "force use of FFmpeg for Chromaprint decoding")
set(WITH_CHROMAPRINT_FFMPEG OFF CACHE BOOL "link FFmpeg only for Chromaprint FFT")
set(WITH_GSTREAMER OFF CACHE BOOL "force use of GStreamer for Chromaprint decoding")
set(WITH_QAUDIODECODER OFF CACHE BOOL "force use of QAudioDecoder for Chromaprint decoding")
set(WITH_NO_MANCOMPRESS OFF CACHE BOOL "disable compressed manpages")
if(ANDROID)
  set(CMAKE_INSTALL_PREFIX "" CACHE PATH "install path prefix" FORCE)
  set(WITH_ID3LIB OFF CACHE BOOL "build with id3lib")
  set(WITH_VORBIS OFF CACHE BOOL "build with Ogg/Vorbis")
  set(WITH_FLAC OFF CACHE BOOL "build with FLAC")
  set(WITH_CHROMAPRINT OFF CACHE BOOL "build with Chromaprint")
else()
  set(WITH_ID3LIB ON CACHE BOOL "build with id3lib")
  set(WITH_VORBIS ON CACHE BOOL "build with Ogg/Vorbis")
  set(WITH_FLAC ON CACHE BOOL "build with FLAC")
  set(WITH_CHROMAPRINT ON CACHE BOOL "build with Chromaprint")
endif()
if(APPLE OR WIN32)
  set(WITH_DBUS OFF CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qt;CLI" CACHE STRING "build applications (Qt;CLI;Test)")
elseif(ANDROID)
  set(WITH_DBUS OFF CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qml" CACHE STRING "build applications (Qml;Qt;CLI;Test)")
else()
  set(WITH_DBUS ON CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qt;CLI;KDE" CACHE STRING "build applications (Qt;CLI;KDE;Test)")
endif()
if(WIN32)
  set(WITH_READLINE OFF CACHE BOOL "build with readline")
else()
  set(WITH_READLINE ON CACHE BOOL "build with readline")
endif()

if(DEFINED WITH_KDE)
  unset(WITH_KDE CACHE)
  message(FATAL_ERROR "The variable WITH_KDE is no longer used. The KDE and Qt "
                      "applications can now be built together using common "
                      "libraries. Use WITH_APPS with a value of \"KDE\" for "
                      "the KDE application, \"Qt\" for the Qt application, "
                      "\"CLI\" for the command line application or "
                      "\"Qt;CLI;KDE\" for all. Default is -DWITH_APPS="
                      "\"${WITH_APPS}\".")
endif()

if(WITH_APPS)
  string(TOLOWER "${WITH_APPS}" _apps_lower)
  foreach(_app ${_apps_lower})
    if(_app STREQUAL "qt")
      set(BUILD_QT_APP ON)
    elseif(_app STREQUAL "qml")
      set(BUILD_QML_APP ON)
      set(WITH_QML ON)
    elseif(_app STREQUAL "cli")
      set(BUILD_CLI_APP ON)
    elseif(_app STREQUAL "kde")
      set(BUILD_KDE_APP ON)
    elseif(_app STREQUAL "test")
      set(BUILD_TEST_APP ON)
    else()
      message(SEND_ERROR "Invalid value ${_app} in WITH_APPS. "
                         "Supported applications are \"Qt;KDE;Test\".")
    endif()
  endforeach()
endif()

if(NOT BUILD_SHARED_LIBS AND WITH_QML)
  message(WARNING "Switching off WITH_QML because of static build")
  set(WITH_QML OFF)
  set(BUILD_QML_APP OFF)
endif()


# Version information
set(CPACK_PACKAGE_VERSION_MAJOR 3)
set(CPACK_PACKAGE_VERSION_MINOR 8)
set(CPACK_PACKAGE_VERSION_PATCH 2)
set(KID3_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION ${KID3_VERSION})
#set(CPACK_PACKAGE_VERSION "git20191214")
set(RELEASE_YEAR 2020)

# Platform specific default installation paths
if(APPLE)
  set(WITH_DATAROOTDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_DOCDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_TRANSLATIONSDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_QMLDIR_DEFAULT "kid3.app/Contents/Resources/qml")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT "kid3.app/Contents/MacOS")
  set(WITH_PLUGINSDIR_DEFAULT "kid3.app/Contents/PlugIns")
elseif(WIN32)
  set(WITH_DATAROOTDIR_DEFAULT ".")
  set(WITH_DOCDIR_DEFAULT ".")
  set(WITH_TRANSLATIONSDIR_DEFAULT ".")
  set(WITH_QMLDIR_DEFAULT "./qml")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
  set(WITH_PLUGINSDIR_DEFAULT "./plugins")
elseif(ANDROID)
  set(WITH_DATAROOTDIR_DEFAULT ".")
  set(WITH_DOCDIR_DEFAULT ".")
  set(WITH_TRANSLATIONSDIR_DEFAULT ":/translations")
  set(WITH_QMLDIR_DEFAULT ":/")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
  set(WITH_PLUGINSDIR_DEFAULT ".")
  set(QT_ANDROID_APP_VERSION ${KID3_VERSION})
  set(QT_ANDROID_APP_VERSION_CODE 18)
else()
  set(WITH_DATAROOTDIR_DEFAULT "share")
  set(WITH_DOCDIR_DEFAULT "share/doc/kid3-qt")
  if(BUILD_KDE_APP OR BUILD_SHARED_LIBS)
    set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3/translations")
  else()
    set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3-qt/translations")
  endif()
  set(WITH_QMLDIR_DEFAULT "share/kid3/qml")
  set(WITH_BINDIR_DEFAULT "bin")
  set(WITH_LIBDIR_DEFAULT "lib${LIB_SUFFIX}/kid3")
  set(WITH_PLUGINSDIR_DEFAULT "${WITH_LIBDIR_DEFAULT}/plugins")
endif()

set(WITH_DATAROOTDIR ${WITH_DATAROOTDIR_DEFAULT} CACHE STRING
    "data root directory relative to CMAKE_INSTALL_PREFIX")
if(BUILD_KDE_APP)
  set(WITH_DBUSDIR "share/dbus-1/interfaces" CACHE STRING
      "dbus directory relative to CMAKE_INSTALL_PREFIX")
endif()
set(WITH_DOCDIR ${WITH_DOCDIR_DEFAULT} CACHE STRING
    "documentation directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_TRANSLATIONSDIR ${WITH_TRANSLATIONSDIR_DEFAULT} CACHE STRING
    "translations directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_BINDIR ${WITH_BINDIR_DEFAULT} CACHE STRING
    "binary directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_LIBDIR ${WITH_LIBDIR_DEFAULT} CACHE STRING
    "library directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_PLUGINSDIR ${WITH_PLUGINSDIR_DEFAULT} CACHE STRING
    "plugin directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_MANDIR ${WITH_DATAROOTDIR}/man CACHE STRING
    "man documentation directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_QMLDIR ${WITH_QMLDIR_DEFAULT} CACHE STRING
    "QML directory relative to CMAKE_INSTALL_PREFIX")
if(CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX_SLASH "${CMAKE_INSTALL_PREFIX}/")
else()
  set(CMAKE_INSTALL_PREFIX_SLASH "")
endif()

if(APPLE)
  file(RELATIVE_PATH CFG_DATAROOTDIR "/kid3.app/Contents/MacOS" /${WITH_DATAROOTDIR})
  file(RELATIVE_PATH CFG_DOCDIR "/kid3.app/Contents/MacOS" /${WITH_DOCDIR})
  file(RELATIVE_PATH CFG_TRANSLATIONSDIR "/kid3.app/Contents/MacOS" /${WITH_TRANSLATIONSDIR})
  file(RELATIVE_PATH CFG_QMLDIR "/kid3.app/Contents/MacOS" /${WITH_QMLDIR})
  file(RELATIVE_PATH CFG_PLUGINSDIR "/kid3.app/Contents/MacOS" /${WITH_PLUGINSDIR})
else()
  set(CFG_DATAROOTDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DATAROOTDIR})
  set(CFG_DOCDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DOCDIR})
  set(CFG_TRANSLATIONSDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_TRANSLATIONSDIR})
  set(CFG_QMLDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_QMLDIR})
  file(RELATIVE_PATH CFG_PLUGINSDIR /${WITH_BINDIR} /${WITH_PLUGINSDIR})
endif()
if(CFG_PLUGINSDIR STREQUAL "")
  set(CFG_PLUGINSDIR ".")
endif()
if(WITH_QMLDIR MATCHES "^:/")
  set(HAVE_QMLDIR_IN_QRC 1)
endif()
if(WITH_TRANSLATIONSDIR MATCHES "^:/")
  set(HAVE_TRANSLATIONSDIR_IN_QRC 1)
endif()
set(CFG_QMLSRCDIR "${kid3_SOURCE_DIR}/src/qml")

find_package(Threads)
find_package(PythonInterp REQUIRED)
include (CheckCXXSourceCompiles)
include (CheckCXXCompilerFlag)
include (CheckLibraryExists)

# Find Qt
set(_qt5Dir)
string(REGEX MATCH "^(.*[Qq]t[/\\]?5.*).bin.qmake.*" _qt5Dir "${QT_QMAKE_EXECUTABLE}")
if(_qt5Dir)
  set(_qt5Dir ${CMAKE_MATCH_1})
endif()

if(_qt5Dir)
  set(Qt5Core_DIR "${_qt5Dir}/lib/cmake/Qt5Core")
  find_package(Qt5Core)
  if(Qt5Core_FOUND)
    message(STATUS "Qt5Core found in ${_qt5Dir}")
    set(Qt5_DIR "${_qt5Dir}/lib/cmake/Qt5")
    set(Qt5Gui_DIR "${_qt5Dir}/lib/cmake/Qt5Gui")
    set(Qt5Widgets_DIR "${_qt5Dir}/lib/cmake/Qt5Widgets")
    set(Qt5Network_DIR "${_qt5Dir}/lib/cmake/Qt5Network")
    set(Qt5Xml_DIR "${_qt5Dir}/lib/cmake/Qt5Xml")
    set(Qt5Multimedia_DIR "${_qt5Dir}/lib/cmake/Qt5Multimedia")
    set(Qt5LinguistTools_DIR "${_qt5Dir}/lib/cmake/Qt5LinguistTools")
    set(Qt5Test_DIR "${_qt5Dir}/lib/cmake/Qt5Test")
    if(WITH_DBUS)
      set(Qt5DBus_DIR "${_qt5Dir}/lib/cmake/Qt5DBus")
    endif()
    if(WITH_QML)
      set(Qt5Qml_DIR "${_qt5Dir}/lib/cmake/Qt5Qml")
      set(Qt5Quick_DIR "${_qt5Dir}/lib/cmake/Qt5Quick")
    endif()
    if(BUILD_QML_APP)
      set(Qt5Svg_DIR "${_qt5Dir}/lib/cmake/Qt5Svg")
      set(Qt5QuickControls2_DIR "${_qt5Dir}/lib/cmake/Qt5QuickControls2")
    endif()
    if(ANDROID)
      set(Qt5AndroidExtras_DIR "${_qt5Dir}/lib/cmake/Qt5AndroidExtras")
    endif()
  endif()
else()
  find_package(Qt5Core)
endif()
if(Qt5Core_FOUND)
  set(_qtComponents Core Gui Widgets Network Xml Multimedia LinguistTools Test)
  if(WITH_DBUS)
    set(_qtComponents ${_qtComponents} DBus)
  endif()
  if(WITH_QML)
    set(_qtComponents ${_qtComponents} Qml Quick)
  endif()
  if(BUILD_QML_APP)
    set(_qtComponents ${_qtComponents} Svg QuickControls2)
  endif()
  if(ANDROID)
    set(_qtComponents ${_qtComponents} AndroidExtras)
  endif()
  find_package(Qt5 COMPONENTS ${_qtComponents} REQUIRED)

  if(WITH_DBUS)
    set(HAVE_QTDBUS 1)
  endif()
  get_target_property(QT_LIBRARY_DIR Qt5::Core LOCATION)
  get_filename_component(QT_LIBRARY_DIR ${QT_LIBRARY_DIR} PATH)
  if(APPLE)
    # For Mac Qt5.5.0 QT_LIBRARY_DIR is wrong
    # (<installdir>/Qt5.5.0/5.5/clang_64/lib/QtCore.framework), fix it.
    string(REGEX MATCH "^(.*)/QtCore.framework$" _qt5LibDir "${QT_LIBRARY_DIR}")
    if(_qt5LibDir)
      set(QT_LIBRARY_DIR ${CMAKE_MATCH_1})
    endif()
  endif()
  if(TARGET Qt5::lupdate)
    get_target_property(QT_LUPDATE_EXECUTABLE Qt5::lupdate LOCATION)
  endif()
  if(TARGET Qt5::QJpegPlugin)
    get_target_property(QT_PLUGINS_DIR Qt5::QJpegPlugin LOCATION)
  endif()
  if(QT_PLUGINS_DIR)
    get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
    get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
  elseif(_qt5Dir)
    set(QT_PLUGINS_DIR ${_qt5Dir}/plugins)
  else()
    # Before Qt 5.2, there seems to be no way to get the plugins directory.
    # Assume it is on the same level as the bin directory.
    get_filename_component(QT_PLUGINS_DIR ${QT_LUPDATE_EXECUTABLE} PATH)
    get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
    set(QT_PLUGINS_DIR ${QT_PLUGINS_DIR}/plugins)
  endif()

  get_target_property(_qmakeLocation Qt5::qmake LOCATION)
  message(STATUS "Found Qt-Version ${Qt5Core_VERSION_STRING} (using ${_qmakeLocation})")
endif()

if(NOT Qt5Core_FOUND)
  message(FATAL_ERROR "Qt5 not found.")
endif()

if(LINUX_SELF_CONTAINED)
  set(CPACK_INSTALL_PREFIX "")
  # Avoid GLIBC_2.14 not found errors on older systems like Debian Wheezy.
  # http://stackoverflow.com/questions/8823267/linking-against-older-symbol-version-in-a-so-file
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -include ${CMAKE_CURRENT_SOURCE_DIR}/linux/glibc_version_nightmare.h")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -include ${CMAKE_CURRENT_SOURCE_DIR}/linux/glibc_version_nightmare.h")
  # Use RPATH instead of RUNPATH, the RPATH of the loading executable has to be used, see
  # http://blog.qt.io/blog/2011/10/28/rpath-and-runpath/
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--disable-new-dtags")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--disable-new-dtags")
endif()

# Check that QT_NO_DEBUG is defined for release configurations

=== doc/CMakeLists.txt ===
# Create HTML handbook from DocBook file in language directory
macro(kid3_create_handbook _docbook _lang)
  get_filename_component(_input ${_docbook} ABSOLUTE)
  set(_output ${CMAKE_CURRENT_BINARY_DIR}/${_lang}/kid3_${_lang}.html)
  set(_fixdocbook_py ${CMAKE_CURRENT_SOURCE_DIR}/fixdocbook.py)
  set(_fixhtml_py ${CMAKE_CURRENT_SOURCE_DIR}/fixhtml.py)
  set(_docbook_xsl ${DOCBOOK_XSL_DIR}/html/docbook.xsl)
  if(WIN32)
    # The expressions in pipes do not work for Windows,
    # so temporary files are used.
    set(_tmp_xml ${CMAKE_CURRENT_BINARY_DIR}/${_lang}/tmp.xml)
    set(_tmp_html ${CMAKE_CURRENT_BINARY_DIR}/${_lang}/tmp.html)
    add_custom_command(OUTPUT ${_tmp_xml}
      COMMAND ${PYTHON_EXECUTABLE} ${_fixdocbook_py} ${_input} >${_tmp_xml}
      DEPENDS ${_input}
    )
    add_custom_command(OUTPUT ${_tmp_html}
      COMMAND ${XSLTPROC} --novalid --nonet ${_docbook_xsl} ${_tmp_xml} >${_tmp_html}
      DEPENDS ${_tmp_xml}
    )
    add_custom_command(OUTPUT ${_output}
      COMMAND ${PYTHON_EXECUTABLE} ${_fixhtml_py} <${_tmp_html} >${_output}
      DEPENDS ${_tmp_html}
    )
  else()
    add_custom_command(OUTPUT ${_output}
      COMMAND
        ${PYTHON_EXECUTABLE} ${_fixdocbook_py} ${_input} |
        ${XSLTPROC} --novalid --nonet ${_docbook_xsl} - |
        ${PYTHON_EXECUTABLE} ${_fixhtml_py} >${_output}
      DEPENDS ${_input}
    )
  endif()
  add_custom_target("${_lang}-html-handbook" ALL DEPENDS ${_output})
  install(FILES ${_output} DESTINATION ${WITH_DOCDIR})
endmacro()

# Create handbook for KDE 5.
# Replace meinproc5 with wrapper to change DTD version, then generate KDE help.
macro(kf5_create_handbook _docbook _lang)
  cmake_minimum_required(VERSION 3.3)
  find_package(ECM REQUIRED NO_MODULE)
  set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
  include(KDEInstallDirs)
  find_package(KF5 REQUIRED COMPONENTS DocTools)
  set(KDOCTOOLS_MEINPROC_EXECUTABLE ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/kf5-meinproc-wrapper.py)
  kdoctools_create_handbook(${_docbook} INSTALL_DESTINATION ${HTML_INSTALL_DIR}/${_lang} SUBDIR kid3)
endmacro()

if(UNIX)
  if(NOT WITH_NO_MANCOMPRESS)
    find_program(GZIP_EXECUTABLE gzip)
  endif()

  # Create man page from DocBook file in language directory
  macro(kid3_create_manpage _docbook _lang)
    get_filename_component(_input ${_docbook} ABSOLUTE)
    set(_output ${CMAKE_CURRENT_BINARY_DIR}/${_lang}/kid3.1)
    set(_fixdocbook_py ${CMAKE_CURRENT_SOURCE_DIR}/fixmandocbook.py)
    set(_docbook_xsl ${DOCBOOK_XSL_DIR}/manpages/docbook.xsl)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_lang})
    add_custom_command(OUTPUT ${_output}
      COMMAND
        ${PYTHON_EXECUTABLE} ${_fixdocbook_py} ${_input} |
        ${XSLTPROC} --novalid --nonet ${_docbook_xsl} -
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_lang}
      DEPENDS ${_input}
    )
    if(WITH_NO_MANCOMPRESS)
      set(_gzExt "")
      set(_output_gz ${_output})
    else()
      set(_gzExt ".gz")
      set(_output_gz ${_output}${_gzExt})
      add_custom_command(OUTPUT ${_output_gz}
        COMMAND ${GZIP_EXECUTABLE} -cn ${_output} >${_output_gz}
        DEPENDS ${_output}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_lang}
      )
    endif()
    add_custom_target("${_lang}-man-handbook" ALL DEPENDS ${_output_gz})
    if(_lang STREQUAL "en")
      set(_install_dir ${WITH_MANDIR}/man1)
    else()
      set(_install_dir ${WITH_MANDIR}/${_lang}/man1)
    endif()
    install(FILES ${_output_gz} DESTINATION ${_install_dir})
    if(BUILD_QT_APP)
      install(CODE
        "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink kid3.1${_gzExt} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_install_dir}/kid3-qt.1${_gzExt}\")")
    endif()
    if(BUILD_CLI_APP)
      install(CODE
        "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink kid3.1${_gzExt} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_install_dir}/kid3-cli.1${_gzExt}\")")
    endif()
  endmacro()
endif()

if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/docs")
  if(BUILD_KDE_APP)
    file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/kf5-meinproc-wrapper.py
         CONTENT "#!/usr/bin/env python
import sys, os, tempfile
args = sys.argv[1:]
docbook = args.pop()
out_fh = tempfile.NamedTemporaryFile(mode='wb')
with open(docbook, 'rb') as in_fh:
    for line in in_fh:
        line = line.replace(
            b'\"-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN\" \"dtd/kdex.dtd\"',
            b'\"-//KDE//DTD DocBook XML V4.5-Based Variant V1.1//EN\" \"dtd/kdedbx45.dtd\"')
        out_fh.write(line)
out_fh.flush()
args.append(out_fh.name)
os.execv('$<TARGET_FILE:KF5::meinproc5>', args)
")
  endif()

  file(GLOB _languages RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/docs" docs/*)
  list(APPEND _languages en)
  foreach(_lang ${_languages})
    if(_lang STREQUAL "en")
      set(_dir ${CMAKE_CURRENT_SOURCE_DIR}/en)
    else()
      set(_dir ${CMAKE_CURRENT_SOURCE_DIR}/docs/${_lang})
    endif()

    if(BUILD_KDE_APP)
      kf5_create_handbook(${_dir}/index.docbook ${_lang})
    endif()

    if(BUILD_QT_APP)
      kid3_create_handbook(${_dir}/index.docbook ${_lang})
    endif()

    if(UNIX)
      kid3_create_manpage(${_dir}/index.docbook ${_lang})
    endif()
  endforeach()
endif()

=== src/CMakeLists.txt ===
set(PLUGIN_LIBRARIES)
add_subdirectory(plugins)
add_subdirectory(core)
add_subdirectory(gui)
add_subdirectory(app)

if(WITH_QML)
  add_subdirectory(qml)
endif()

if(BUILD_TEST_APP)
  add_subdirectory(test)
endif()

=== translations/CMakeLists.txt ===
if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/po")
  # Using ecm_install_po_files_as_qm() from ECMPoQmTools does not work
  # because the generated ts files do not have context information,
  # just one single context with an empty name.

  file(GLOB _languages RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/po" po/*)
  list(REMOVE_ITEM _languages kid3_qt.pot)
  set(_poFiles)
  set(_tsFiles)

  foreach(_lang ${_languages})
    set(_poFiles ${_poFiles} ${CMAKE_CURRENT_SOURCE_DIR}/po/${_lang}/kid3_qt.po)
    set(_tsFiles ${_tsFiles} ${CMAKE_CURRENT_BINARY_DIR}/kid3_${_lang}.ts)
  endforeach()

  if(APPLE OR WIN32 OR ANDROID OR LINUX_SELF_CONTAINED)
    if(NOT QT_TRANSLATIONS_DIR)
      get_target_property(QT_TRANSLATIONS_DIR Qt5::qmake LOCATION)
      get_filename_component(QT_TRANSLATIONS_DIR ${QT_TRANSLATIONS_DIR} PATH)
      get_filename_component(QT_TRANSLATIONS_DIR ${QT_TRANSLATIONS_DIR} PATH)
      set(QT_TRANSLATIONS_DIR "${QT_TRANSLATIONS_DIR}/translations")
    endif()

    # Also copy or convert the Qt language files from the Qt installation.
    set(_qtQmFiles)
    set(_qtTsFiles)
    set(_qtCopiedQmFiles)

    set(_qttranslation_prefix "${QT_TRANSLATIONS_DIR}/qtbase_")
    set(_qtCopiedQm_prefix "${CMAKE_CURRENT_BINARY_DIR}/qtbase_")
    foreach(_lang ${_languages})
      if(EXISTS ${_qttranslation_prefix}${_lang}.qm)
        set(_qtQmFiles ${_qtQmFiles} ${_qttranslation_prefix}${_lang}.qm)
        if(HAVE_TRANSLATIONSDIR_IN_QRC)
          set(_qtCopiedQmFiles ${_qtCopiedQmFiles} ${_qtCopiedQm_prefix}${_lang}.qm)
        endif()
      elseif(EXISTS ${_qttranslation_prefix}${_lang}.ts)
        set(_qtTsFiles ${_qtTsFiles} ${_qttranslation_prefix}${_lang}.ts)
      endif()
    endforeach()
  endif()

  if(_tsFiles)
    add_custom_command(
       OUTPUT ${_tsFiles}
       COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/po2ts.py
         ${QT_LUPDATE_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/po
         ${CMAKE_CURRENT_SOURCE_DIR}/../src
       DEPENDS ${_poFiles}
    )
  endif()

  if(_qtCopiedQmFiles)
    add_custom_command(
      OUTPUT ${_qtCopiedQmFiles}
      COMMAND ${CMAKE_COMMAND} -E copy ${_qtQmFiles} ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS ${_qtQmFiles}
    )
  endif()

  if(APPLE OR WIN32 OR ANDROID OR LINUX_SELF_CONTAINED)
    qt5_add_translation(_qmFiles ${_tsFiles} ${_qtTsFiles})
    add_custom_target(translations "ALL" DEPENDS ${_qmFiles} ${_qtCopiedQmFiles})
    set(_installQmFiles ${_qmFiles} ${_qtQmFiles})
  else()
    qt5_add_translation(_qmFiles ${_tsFiles})
    add_custom_target(translations "ALL" DEPENDS ${_qmFiles})
    set(_installQmFiles ${_qmFiles})
  endif()
  if(NOT HAVE_TRANSLATIONSDIR_IN_QRC)
    install(FILES ${_installQmFiles} DESTINATION ${WITH_TRANSLATIONSDIR})
  endif()
endif()

=== src/core/CMakeLists.txt ===
option(WITH_QT_PRIVATE_HEADERS "Use private Qt headers" OFF)

qt5_wrap_cpp(core_GEN_MOC_SRCS
  utils/debugutils.h
  config/batchimportsourcesmodel.h
  config/batchimportconfig.h
  config/filterconfig.h
  config/formatconfig.h
  config/generalconfig.h
  config/importconfig.h
  config/exportconfig.h
  config/tagconfig.h
  config/fileconfig.h
  config/rendirconfig.h
  config/numbertracksconfig.h
  config/useractionsconfig.h
  config/guiconfig.h
  config/networkconfig.h
  config/playlistconfig.h
  config/serverimporterconfig.h
  config/findreplaceconfig.h
  config/mainwindowconfig.h
  config/starratingmappingsmodel.h
  tags/frame.h
  tags/framenotice.h
  import/batchimporter.h
  import/httpclient.h
  import/importclient.h
  import/serverimporter.h
  import/servertrackimporter.h
  model/commandstablemodel.h
  model/dirrenamer.h
  model/downloadclient.h
  model/externalprocess.h
  model/filefilter.h
  model/fileproxymodel.h
  model/fileproxymodeliterator.h
  model/bidirfileproxymodeliterator.h
  model/framelist.h
  model/frametablemodel.h
  model/kid3application.h
  model/trackdatamodel.h
  model/tagsearcher.h
  model/timeeventmodel.h
  model/taggedfileselection.h
  model/genremodel.h
  model/frameeditorobject.h
  model/frameobjectmodel.h
  model/playlistmodel.h
  model/proxyitemselectionmodel.h
  model/filesystemmodel.h
  model/fileinfogatherer_p.h
  model/standardtablemodel.h
  TARGET kid3-core
)
if(HAVE_QTDBUS)
  qt5_wrap_cpp(qtdbus_GEN_MOC_SRCS
    model/scriptinterface.h
    TARGET kid3-core
  )
endif()
if(ANDROID)
  qt5_wrap_cpp(android_GEN_MOC_SRCS
    utils/androidutils.h
    TARGET kid3-core
  )
endif()

add_library(kid3-core
  utils/debugutils.cpp
  utils/saferename.cpp
  utils/loadtranslation.cpp
  utils/icoreplatformtools.cpp
  utils/coreplatformtools.cpp
  config/batchimportconfig.cpp
  config/batchimportprofile.cpp
  config/batchimportsourcesmodel.cpp
  config/configstore.cpp
  config/filterconfig.cpp
  config/formatconfig.cpp
  config/generalconfig.cpp
  config/importconfig.cpp
  config/exportconfig.cpp
  config/tagconfig.cpp
  config/fileconfig.cpp
  config/rendirconfig.cpp
  config/numbertracksconfig.cpp
  config/useractionsconfig.cpp
  config/guiconfig.cpp
  config/networkconfig.cpp
  config/playlistconfig.cpp
  config/serverimporterconfig.cpp
  config/isettings.cpp
  config/kid3settings.cpp
  config/findreplaceconfig.cpp
  config/mainwindowconfig.cpp
  config/starratingmappingsmodel.cpp
  tags/attributedata.cpp
  tags/genres.cpp
  tags/formatreplacer.cpp
  tags/frame.cpp
  tags/framenotice.cpp
  tags/pictureframe.cpp
  tags/taggedfile.cpp
  tags/itaggedfilefactory.cpp
  tags/trackdata.cpp
  export/playlistcreator.cpp
  export/textexporter.cpp
  import/batchimporter.cpp
  import/httpclient.cpp
  import/importclient.cpp
  import/importparser.cpp
  import/iserverimporterfactory.cpp
  import/iservertrackimporterfactory.cpp
  import/jsonparser.cpp
  import/serverimporter.cpp
  import/servertrackimporter.cpp
  import/textimporter.cpp
  import/trackdatamatcher.cpp
  model/iabortable.cpp
  model/commandformatreplacer.cpp
  model/commandstablemodel.cpp
  model/configtablemodel.cpp
  model/dirproxymodel.cpp
  model/dirrenamer.cpp
  model/downloadclient.cpp
  model/expressionparser.cpp
  model/externalprocess.cpp
  model/filefilter.cpp
  model/fileproxymodel.cpp
  model/fileproxymodeliterator.cpp
  model/bidirfileproxymodeliterator.cpp
  model/framelist.cpp
  model/frametablemodel.cpp
  model/iframeeditor.cpp
  model/kid3application.cpp
  model/modeliterator.cpp
  model/coretaggedfileiconprovider.cpp
  model/texttablemodel.cpp
  model/trackdatamodel.cpp
  model/checkablestringlistmodel.cpp
  model/tagsearcher.cpp
  model/timeeventmodel.cpp
  model/eventtimingcode.cpp
  model/taggedfileselection.cpp
  model/genremodel.cpp
  model/frameeditorobject.cpp
  model/frameobjectmodel.cpp
  model/iusercommandprocessor.cpp
  model/playlistmodel.cpp
  model/proxyitemselectionmodel.cpp
  model/filesystemmodel.cpp
  model/fileinfogatherer.cpp
  model/abstractfiledecorationprovider.cpp
  model/standardtablemodel.cpp
)
if(HAVE_QTDBUS)
  target_sources(kid3-core PRIVATE model/scriptinterface.cpp)
endif()
if(ANDROID)
  target_sources(kid3-core PRIVATE utils/androidutils.cpp)
endif()
target_sources(kid3-core PRIVATE ${core_GEN_MOC_SRCS})
if(HAVE_QTDBUS)
  target_sources(kid3-core PRIVATE ${qtdbus_GEN_MOC_SRCS})
endif()
if(ANDROID)
  target_sources(kid3-core PRIVATE ${android_GEN_MOC_SRCS})
endif()

target_include_directories(kid3-core PUBLIC utils config tags export import model)

target_compile_definitions(kid3-core
  PRIVATE KID3_BUILD_CORE_LIB
  PUBLIC QT_ASCII_CAST_WARNINGS QT_NO_CAST_TO_ASCII QT_NO_URL_CAST_FROM_STRING QT_STRICT_ITERATORS QT_NO_EXCEPTIONS QT_NO_STL
)

set_target_properties(kid3-core PROPERTIES VERSION ${KID3_VERSION})
if(CMAKE_VERSION VERSION_GREATER "3.8")
  target_compile_features(kid3-core PUBLIC cxx_std_11)
else()
  target_compile_features(kid3-core PUBLIC cxx_auto_type cxx_nullptr cxx_override)
endif()
target_link_libraries(kid3-core PUBLIC Qt5::Core Qt5::Network Qt5::Xml)
if(WITH_QT_PRIVATE_HEADERS)
  target_compile_definitions(kid3-core PRIVATE USE_QT_PRIVATE_HEADERS)
  target_link_libraries(kid3-core PRIVATE Qt5::CorePrivate)
endif()
if(WITH_DBUS)
  target_link_libraries(kid3-core PUBLIC Qt5::DBus)
endif()
if(PLUGIN_LIBRARIES)
  target_link_libraries(kid3-core PUBLIC ${PLUGIN_LIBRARIES})
endif()
if(APPLE)
  target_link_libraries(kid3-core PUBLIC "-framework CoreServices")
endif()
if(ANDROID)
  target_link_libraries(kid3-core PUBLIC Qt5::AndroidExtras)
endif()

if(BUILD_SHARED_LIBS)
  install(TARGETS kid3-core
    LIBRARY DESTINATION ${WITH_LIBDIR}
    RUNTIME DESTINATION ${WITH_BINDIR})
endif()

if(BUILD_KDE_APP)
  install(FILES model/net.sourceforge.Kid3.xml
          DESTINATION ${WITH_DBUSDIR})
endif()

=== src/gui/CMakeLists.txt ===
qt5_wrap_cpp(gui_GEN_MOC_SRCS
  widgets/abstractlistedit.h
  widgets/configtable.h
  widgets/formatbox.h
  widgets/filenameformatbox.h
  widgets/tagformatbox.h
  widgets/formatlistedit.h
  widgets/frametable.h
  widgets/imageviewer.h
  widgets/playtoolbar.h
  widgets/stringlistedit.h
  widgets/timeeventeditor.h
  widgets/timestampdelegate.h
  widgets/chaptereditor.h
  widgets/tableofcontentseditor.h
  widgets/subframeseditor.h
  widgets/progresswidget.h
  widgets/frameitemdelegate.h
  widgets/tablemodeledit.h
  dialogs/batchimportdialog.h
  dialogs/batchimportsourcedialog.h
  dialogs/browsecoverartdialog.h
  dialogs/configdialogpages.h
  dialogs/downloaddialog.h
  dialogs/editframefieldsdialog.h
  dialogs/exportdialog.h
  dialogs/filterdialog.h
  dialogs/importdialog.h
  dialogs/servertrackimportdialog.h
  dialogs/numbertracksdialog.h
  dialogs/playlistdialog.h
  dialogs/rendirdialog.h
  dialogs/serverimportdialog.h
  dialogs/tagimportdialog.h
  dialogs/textimportdialog.h
  dialogs/findreplacedialog.h
  dialogs/playlisteditdialog.h
  forms/filelist.h
  forms/configurabletreeview.h
  forms/kid3form.h
  forms/basemainwindow.h
  forms/playlistview.h
  forms/audioplayer.h
  forms/mprisinterface.h
  TARGET kid3-gui
)

add_library(kid3-gui
  widgets/abstractlistedit.cpp
  widgets/comboboxdelegate.cpp
  widgets/configtable.cpp
  widgets/formatbox.cpp
  widgets/filenameformatbox.cpp
  widgets/tagformatbox.cpp
  widgets/formatlistedit.cpp
  widgets/frametable.cpp
  widgets/imageviewer.cpp
  widgets/picturelabel.cpp
  widgets/playtoolbar.cpp
  widgets/stringlistedit.cpp
  widgets/timeeventeditor.cpp
  widgets/enumdelegate.cpp
  widgets/eventcodedelegate.cpp
  widgets/timestampdelegate.cpp
  widgets/chaptereditor.cpp
  widgets/tableofcontentseditor.cpp
  widgets/subframeseditor.cpp
  widgets/progresswidget.cpp
  widgets/frameitemdelegate.cpp
  widgets/tablemodeledit.cpp
  widgets/tracknumbervalidator.cpp
  dialogs/batchimportdialog.cpp
  dialogs/batchimportsourcedialog.cpp
  dialogs/browsecoverartdialog.cpp
  dialogs/configdialogpages.cpp
  dialogs/contexthelp.cpp
  dialogs/downloaddialog.cpp
  dialogs/editframefieldsdialog.cpp
  dialogs/exportdialog.cpp
  dialogs/filterdialog.cpp
  dialogs/importdialog.cpp
  dialogs/servertrackimportdialog.cpp
  dialogs/numbertracksdialog.cpp
  dialogs/playlistdialog.cpp
  dialogs/rendirdialog.cpp
  dialogs/serverimportdialog.cpp
  dialogs/tagimportdialog.cpp
  dialogs/textimportdialog.cpp
  dialogs/findreplacedialog.cpp
  dialogs/playlisteditdialog.cpp
  dialogs/stringlisteditdialog.cpp
  forms/filelist.cpp
  forms/configurabletreeview.cpp
  forms/kid3form.cpp
  forms/basemainwindow.cpp
  forms/iplatformtools.cpp
  forms/playlistview.cpp
  forms/pixmapprovider.cpp
  forms/taggedfileiconprovider.cpp
  forms/audioplayer.cpp
  forms/mprisinterface.cpp
  forms/guiplatformtools.cpp
  ${gui_GEN_MOC_SRCS}
)

target_include_directories(kid3-gui PRIVATE widgets PUBLIC dialogs forms)

target_compile_definitions(kid3-gui PRIVATE KID3_BUILD_GUI_LIB)

set_target_properties(kid3-gui PROPERTIES VERSION ${KID3_VERSION})
target_link_libraries(kid3-gui kid3-core Qt5::Widgets Qt5::Multimedia)

if(BUILD_SHARED_LIBS)
  install(TARGETS kid3-gui
    LIBRARY DESTINATION ${WITH_LIBDIR}
    RUNTIME DESTINATION ${WITH_BINDIR})
endif()

=== src/qml/CMakeLists.txt ===
if(NOT HAVE_QMLDIR_IN_QRC)
  # Before starting Qt Creator, export the environment variable
  # QML_IMPORT_PATH=<qt5dir>/qml:<qt5dir>/imports
  # so that the editor supports the QML types.
  # On Linux, this can be done in ~/.xsessionrc.
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/script
          DESTINATION ${WITH_QMLDIR}
          FILES_MATCHING PATTERN "*.qml" PATTERN "*.js")

  if(BUILD_QML_APP)
    install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/app
            DESTINATION ${WITH_QMLDIR}
            FILES_MATCHING PATTERN "*.qml" PATTERN "*.js")
    install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/icons
            DESTINATION ${WITH_QMLDIR}
            FILES_MATCHING PATTERN "*.ttf" PATTERN "triangle_*.svg")
  endif()

  # Only used to add the QML sources to the project.
  add_custom_target(qml-sources SOURCES
    script/ReplayGain2SoundCheck.qml
    script/ResizeAlbumArt.qml
    script/QmlConsole.qml
    script/ShowTextEncodingV1.qml
    script/ExportCsv.qml
    script/ImportCsv.qml
    script/ExtractAlbumArt.qml
    script/EmbedAlbumArt.qml
    script/EmbedLyrics.qml
    script/ExportPlaylist.qml
  )
  if(BUILD_QML_APP)
    # Only used to add the QML sources to the project.
    add_custom_target(qmlapp-sources SOURCES
      app/Main.qml
      app/MainPage.qml
      app/Collapsible.qml
      app/FrameDelegate.qml
      app/FrameEditDialog.qml
      app/FrameSelectDialog.qml
      app/MessageDialog.qml
      app/UiConstants.qml
      app/FileList.qml
      app/FileCollapsible.qml
      app/TagCollapsible.qml
      app/PictureCollapsible.qml
      app/FileSelectDialog.qml
      app/RenameDirectoryPage.qml
      app/NumberTracksDialog.qml
      app/FilterPage.qml
      app/BatchImportPage.qml
      app/AbstractSettingsPage.qml
      app/SettingsElement.qml
      app/SettingsPage.qml
      app/SettingsItem.qml
      app/AboutDialog.qml
      app/Empty.qml
      app/Standard.qml
      app/ThinDivider.qml
      app/IconButton.qml
      app/ThinDivider.qml
      app/StringListEditPage.qml
      app/MapEditPage.qml
      app/ImportProfilesEditPage.qml
    )
  endif()  
endif()

=== src/test/CMakeLists.txt ===
qt5_wrap_cpp(test_GEN_MOC_SRCS
  testjsonparser.h
  testserverimporterbase.h
  testmusicbrainzreleaseimporter.h
  testmusicbrainzreleaseimportparser.h
  testdiscogsimporter.h
  TARGET kid3-test
)
add_executable(kid3-test
  dummysettings.cpp
  testutils.cpp
  testjsonparser.cpp
  testserverimporterbase.cpp
  testmusicbrainzreleaseimporter.cpp
  testmusicbrainzreleaseimportparser.cpp
  testdiscogsimporter.cpp
  maintest.cpp
  ${test_GEN_MOC_SRCS}
)
target_link_libraries(kid3-test kid3-core Qt5::Test -lstdc++)

=== src/app/qml/CMakeLists.txt ===
if(NOT ANDROID)
  add_executable(kid3-qml MACOSX_BUNDLE WIN32 mainqml.cpp)
  install(TARGETS kid3-qml
    BUNDLE DESTINATION .
    RUNTIME DESTINATION ${WITH_BINDIR})
else()
  add_library(kid3-qml SHARED mainqml.cpp)
  # Make symbols visible so that main can be found.
  set_target_properties(kid3-qml PROPERTIES COMPILE_FLAGS -fvisibility=default)
endif()

if(HAVE_QMLDIR_IN_QRC)
  qt5_add_resources(qmlapp_GEN_RCS qmlapp.qrc)
  target_sources(kid3-qml PRIVATE ${qmlapp_GEN_RCS})
endif()

if(HAVE_TRANSLATIONSDIR_IN_QRC)
  string(REPLACE ":/" "/" _qrcPrefix ${WITH_TRANSLATIONSDIR})
  add_custom_command(
    OUTPUT translations.qrc
    COMMAND ${CMAKE_COMMAND} -P
      ${CMAKE_CURRENT_SOURCE_DIR}/gentranslationsqrc.cmake
      ${CMAKE_CURRENT_BINARY_DIR}/translations.qrc
      ${CMAKE_CURRENT_BINARY_DIR}/../../../po ${_qrcPrefix}
    DEPENDS translations
  )
  qt5_add_resources(
    translations_GEN_RCS ${CMAKE_CURRENT_BINARY_DIR}/translations.qrc)
  target_sources(kid3-qml PRIVATE ${translations_GEN_RCS})
endif()

target_link_libraries(kid3-qml kid3-gui Qt5::QuickControls2 -lstdc++)

=== src/app/qt/CMakeLists.txt ===
add_executable(${KID3_EXECUTABLE} MACOSX_BUNDLE WIN32
  mainqt.cpp
  platformtools.cpp
  kid3mainwindow.cpp
  kid3qtapplication.cpp
  recentfilesmenu.cpp
  browserdialog.cpp
  messagedialog.cpp
  configdialog.cpp
  shortcutsmodel.cpp
  shortcutsdelegate.cpp
)
qt5_wrap_cpp(qt_GEN_MOC_SRCS
  kid3mainwindow.h
  kid3qtapplication.h
  recentfilesmenu.h
  browserdialog.h
  messagedialog.h
  configdialog.h
  shortcutsmodel.h
  shortcutsdelegate.h
  TARGET ${KID3_EXECUTABLE}
)
target_sources(${KID3_EXECUTABLE} PRIVATE ${qt_GEN_MOC_SRCS})

if(APPLE)
  # Icon and properties for .plist file
  set(MACOSX_BUNDLE_BUNDLE_NAME "Kid3")
  set(MACOSX_BUNDLE_BUNDLE_EXECUTABLE "kid3")
  set(MACOSX_BUNDLE_ICON_FILE kid3.icns)
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CPACK_PACKAGE_VERSION})
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.kid3")
  set(MACOSX_BUNDLE_COPYRIGHT "Copyright (c) 2003-${RELEASE_YEAR} Urs Fleisch")
  set_source_files_properties(kid3.icns
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  target_sources(${KID3_EXECUTABLE} PRIVATE kid3.icns)
  set_source_files_properties(qt.conf
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  target_sources(${KID3_EXECUTABLE} PRIVATE qt.conf)
elseif(WIN32)
  if(MINGW)
    # support for Windows resource files with MinGW
    set(CMAKE_RC_COMPILER_INIT windres)
    enable_language(RC)
    set(CMAKE_RC_COMPILE_OBJECT
      "<CMAKE_RC_COMPILER> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
  endif()
  # add Windows resource file with icon
  target_sources(${KID3_EXECUTABLE} PRIVATE kid3win.rc)
endif()

if(UNIX AND NOT APPLE)
  find_program(GZIP_PROGRAM gzip)
  # install desktop file and icons for Linux
  add_custom_command(OUTPUT kid3-qt.desktop
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixdesktop.py
      <${CMAKE_CURRENT_SOURCE_DIR}/../kid3.desktop >kid3-qt.desktop
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.desktop
  )
  add_custom_target("desktop-file" ALL DEPENDS kid3-qt.desktop)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.desktop
    DESTINATION "${WITH_DATAROOTDIR}/applications"
    RENAME net.sourceforge.kid3-qt.desktop)
  add_custom_command(OUTPUT kid3-qt.appdata.xml
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixappdata.py
      ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.appdata.xml >kid3-qt.appdata.xml
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.appdata.xml
  )
  add_custom_target("appdata-file" ALL DEPENDS kid3-qt.appdata.xml)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.appdata.xml
    DESTINATION "${WITH_DATAROOTDIR}/metainfo"
    RENAME net.sourceforge.kid3-qt.appdata.xml)
  if(GZIP_PROGRAM)
    add_custom_command(OUTPUT kid3-qt.svg
      COMMAND ${GZIP_PROGRAM} -cdn ${CMAKE_CURRENT_SOURCE_DIR}/../sc-apps-kid3.svgz >kid3-qt.svg
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../sc-apps-kid3.svgz
    )
    target_sources(${KID3_EXECUTABLE} PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps")
  else()
    install(FILES ../sc-apps-kid3.svgz
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps"
            RENAME kid3-qt.svgz)
  endif()
  install(FILES ../128-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/128x128/apps"
          RENAME kid3-qt.png)
  install(FILES ../64-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/64x64/apps"
          RENAME kid3-qt.png)
  install(FILES ../48-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/48x48/apps"
          RENAME kid3-qt.png)
  install(FILES ../32-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/32x32/apps"
          RENAME kid3-qt.png)
  install(FILES ../16-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/16x16/apps"
          RENAME kid3-qt.png)
elseif(APPLE)
  install(FILES ../48-apps-kid3.png
          DESTINATION ${WITH_DATAROOTDIR}
          RENAME kid3.png)
endif()

qt5_add_resources(qt_GEN_RCS kid3.qrc)
target_sources(${KID3_EXECUTABLE} PRIVATE
  ${qt_GEN_RCS}
)

target_link_libraries(${KID3_EXECUTABLE} kid3-gui -lstdc++)

if(APPLE)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../../../macosx/Info.plist.in
                 ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  set_target_properties(${KID3_EXECUTABLE} PROPERTIES
      MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  if(CMAKE_CXX_COMPILER MATCHES "/osxcross/")
    # When cross compiling, CPack does not know that is should be APPLE.
    install(CODE "
  set(APPLE TRUE)
  ")
  endif()
endif()

install(TARGETS ${KID3_EXECUTABLE}
  BUNDLE DESTINATION .
  RUNTIME DESTINATION ${WITH_BINDIR})

if(LINUX_SELF_CONTAINED)
  # Change RPATH/RUNPATH of executable/library.
  macro(CHANGE_RPATH _rpath _file)
    install(CODE "
      execute_process(COMMAND chrpath -r ${_rpath} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_file}\"
                      RESULT_VARIABLE ret)
      if(NOT ret EQUAL 0)
        message(FATAL_ERROR \"chrpath failed with \${ret}\")
      endif()
      ")
  endmacro()

  set_target_properties(${KID3_EXECUTABLE} PROPERTIES INSTALL_RPATH "\$ORIGIN")
endif()

if(APPLE OR WIN32 OR LINUX_SELF_CONTAINED)

  # Put Qt libraries and plugins into installation package to create a
  # standalone bundle on Mac OS X and Windows
  set(plugin_dest_dir ${WITH_BINDIR})
  set(bundle_app
   "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/${KID3_EXECUTABLE}")
  if(APPLE)
    set(plugin_dest_dir kid3.app/Contents/PlugIns)
    set(bundle_app "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app")
  endif()
  if(WIN32)
    set(bundle_app
      "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/kid3.exe")
  endif()
  string(REPLACE "/./" "/" bundle_app ${bundle_app})

  # Install Qt JPEG and Phonon plugins
  install(DIRECTORY "${QT_PLUGINS_DIR}/imageformats"
    DESTINATION ${plugin_dest_dir}
    FILES_MATCHING PATTERN "*jpeg${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*jpeg4${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*.dSYM" EXCLUDE)

  if(LINUX_SELF_CONTAINED)
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/imageformats/libqjpeg${CMAKE_SHARED_LIBRARY_SUFFIX}")
  endif()
  if(APPLE)
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
      DESTINATION kid3.app/Contents/MacOS
      FILES_MATCHING PATTERN "libqcocoa${CMAKE_SHARED_LIBRARY_SUFFIX}"
                     PATTERN "*.dSYM" EXCLUDE)
    install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libqavfmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}"
                     PATTERN "*.dSYM" EXCLUDE)
  elseif(WIN32)
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "qwindows${CMAKE_SHARED_LIBRARY_SUFFIX}")
    install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "dsengine${CMAKE_SHARED_LIBRARY_SUFFIX}")
  elseif(LINUX_SELF_CONTAINED)
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libqxcb${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/platforms/libqxcb${CMAKE_SHARED_LIBRARY_SUFFIX}")
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforminputcontexts"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libcomposeplatforminputcontextplugin${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/platforminputcontexts/libcomposeplatforminputcontextplugin${CMAKE_SHARED_LIBRARY_SUFFIX}")
    install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libgstmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/mediaservice/libgstmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
    install(DIRECTORY "${QT_PLUGINS_DIR}/xcbglintegrations"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libqxcb-glx-integration${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/xcbglintegrations/libqxcb-glx-integration${CMAKE_SHARED_LIBRARY_SUFFIX}")
  endif()

  if(CMAKE_CROSSCOMPILING AND NOT APPLE)
    # Avoid error "/usr/bin/ldd failed: 1" from GetPrerequisites.cmake:800
    # when cross-packaging, this does not seem to be supported.
    # https://public.kitware.com/pipermail/cmake/2012-March/049497.html
    install(CODE "
    set(gp_tool DO_NOT_USE)
    ")
  endif()

  if(LINUX_SELF_CONTAINED)
    # CMake 3.11.1 gets the prerequisites type wrong if a plugin uses a
    # library which is in a parent directory but still inside the bundle.
    # Override the type from "other" to "local" in such cases.
    install(CODE "
    function(gp_resolved_file_type_override resolved_file type_var)
      if(\${\${type_var}} STREQUAL other)
        get_filename_component(bundle_app_path \"${bundle_app}\" PATH)
        string(LENGTH \"\${bundle_app_path}/\" bundle_app_length)
        string(LENGTH \"\${resolved_file}\" resolved_file_length)
        if(\${resolved_file_length} GREATER \${bundle_app_length})
          string(SUBSTRING \"\${resolved_file}\" 0 \${bundle_app_length} resolved_file_path)
          if(resolved_file_path STREQUAL \"\${bundle_app_path}/\")
            set(\${type_var} local PARENT_SCOPE)
          endif()
        endif()
      endif()
    endfunction()
    ")
  endif()

  # Install and fix up all dependencies of the executable and the plugins.
  # On Mac OS X only keep the i386 code in the Qt libraries and plugins.
  install(CODE "
    file(GLOB_RECURSE QTPLUGINS
      \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    if(APPLE)
      file(GLOB_RECURSE QTPLATFORMPLUGINS
        \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app/Contents/MacOS/platforms/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
      set(QTPLUGINS \"\${QTPLUGINS};\${QTPLATFORMPLUGINS}\")
    endif()
    file(GLOB_RECURSE KID3PLUGINS
      \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_PLUGINSDIR}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    include(BundleUtilities)
    set(bundle_libs \"\${QTPLUGINS};\${KID3PLUGINS}\")
    if(APPLE AND BUILD_CLI_APP)
      set(bundle_libs \"\${bundle_libs};\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_LIBDIR}/kid3-cli\")
    endif()
    fixup_bundle(\"${bundle_app}\" \"\${bundle_libs}\" \"${QT_LIBRARY_DIR}\")
    ")

endif()

if(WIN32)
  # Use reduced size ICU libraries, QTBUG-29828, QTBUG-38259.
  # A folder with reduced ICU libraries can be copied to the Qt bin directory.
  get_target_property(_qtBinDir Qt5::Core LOCATION)
  get_filename_component(_qtBinDir ${_qtBinDir} PATH)
  install(DIRECTORY "${_qtBinDir}/icu_reduced/"
          DESTINATION ${WITH_BINDIR} OPTIONAL)
  # Install missing DLLs.
  file(GLOB _sslDlls "${_qtBinDir}/../../../Tools/mingw*/opt/bin/*eay32.dll")
  install(FILES "${_qtBinDir}/Qt5Xml.dll" ${_sslDlls}
          DESTINATION ${WITH_BINDIR})
endif()

if(LINUX_SELF_CONTAINED)
  # Use reduced size ICU libraries.
  # A folder with reduced ICU libraries can be copied to the Qt bin directory.
  get_target_property(_qtBinDir Qt5::qmake LOCATION)
  get_filename_component(_qtBinDir ${_qtBinDir} PATH)
  string(REPLACE "/bin" "/lib" _qtLibDir "${_qtBinDir}")
  install(CODE "
    if(EXISTS \"${_qtLibDir}/icu_reduced\")
      file(GLOB _iculibs \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/libicu*\")
      if(_iculibs)
        file(REMOVE \${_iculibs})
      endif()
    endif()
  ")
  install(DIRECTORY "${_qtLibDir}/icu_reduced/"
          DESTINATION ${WITH_BINDIR} OPTIONAL)
  # Qt searches for OpenSSL 1.0, which is not found on distributions
  # as new as Ubuntu 18.04. Install them in the application directory.
  install(FILES "${CMAKE_BINARY_DIR}/../buildroot/usr/local/ssl/libssl.so"

=== src/plugins/acoustidimport/CMakeLists.txt ===
if(WITH_CHROMAPRINT)

  set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
  find_package(Chromaprint REQUIRED)
  if(CHROMAPRINT_INCLUDE_DIR AND CHROMAPRINT_LIBRARIES)
    set(HAVE_CHROMAPRINT 1)
  endif()
  if(WITH_FFMPEG)
    find_package(FFmpeg COMPONENTS avformat avcodec avutil REQUIRED)
  elseif(WITH_GSTREAMER)
    find_package(GStreamer REQUIRED)
    if(NOT GSTREAMER_FOUND)
      message(FATAL_ERROR "Could not find GStreamer")
    endif()
  elseif(WITH_QAUDIODECODER)
    message(STATUS "QAudioDecoder selected for decoding.")
  else()
    # Neither FFmpeg nor GStreamer is forced, select FFmpeg if Chromaprint
    # depends on it or if on Windows or Mac OS X.
    include(GetPrerequisites)
    get_prerequisites(${CHROMAPRINT_LIBRARIES} _chromaprintDeps 0 0 "" "")
    if(_chromaprintDeps MATCHES "libavcodec" OR APPLE OR WIN32)
      message(STATUS "FFmpeg selected for decoding, use WITH_GSTREAMER=ON to use GStreamer instead.")
      find_package(FFmpeg COMPONENTS avformat avcodec avutil REQUIRED)
    else()
      message(STATUS "GStreamer selected for decoding, use WITH_FFMPEG=ON to use FFmpeg instead.")
      find_package(GStreamer REQUIRED)
    endif()
  endif()
  if(GSTREAMER_FOUND)
    set(HAVE_GSTREAMER 1)
  elseif(FFMPEG_FOUND)
    set(HAVE_FFMPEG 1)
  endif()

  set(plugin_NAME AcoustidImport)

  string(TOLOWER ${plugin_NAME} plugin_TARGET)

  add_library(${plugin_TARGET}
    abstractfingerprintdecoder.cpp
    fingerprintcalculator.cpp
    musicbrainzclient.cpp
    acoustidimportplugin.cpp
  )

  if(HAVE_GSTREAMER)
    target_sources(${plugin_TARGET} PRIVATE gstfingerprintdecoder.cpp)
  elseif(HAVE_FFMPEG)
    target_sources(${plugin_TARGET} PRIVATE ffmpegfingerprintdecoder.cpp)
  else()
    target_sources(${plugin_TARGET} PRIVATE qtfingerprintdecoder.cpp)
  endif()

  qt5_wrap_cpp(plugin_GEN_MOC_SRCS
    abstractfingerprintdecoder.h
    fingerprintcalculator.h
    musicbrainzclient.h
    acoustidimportplugin.h
    TARGET ${plugin_TARGET}
  )
  target_sources(${plugin_TARGET} PRIVATE ${plugin_GEN_MOC_SRCS})

  if(NOT HAVE_GSTREAMER AND NOT HAVE_FFMPEG)
    qt5_wrap_cpp(qtfp_GEN_MOC_SRCS qtfingerprintdecoder.h TARGET ${plugin_TARGET})
    target_sources(${plugin_TARGET} PRIVATE ${qtfp_GEN_MOC_SRCS})
  endif()

  target_include_directories(${plugin_TARGET} PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
  target_link_libraries(${plugin_TARGET} PRIVATE kid3-core Chromaprint::Chromaprint Kid3Plugin)

  if(HAVE_GSTREAMER)
    target_link_libraries(${plugin_TARGET} PRIVATE GStreamer::GStreamer)
  elseif(HAVE_FFMPEG)
    if(FFmpeg_avformat_FOUND AND FFmpeg_avcodec_FOUND AND FFmpeg_avutil_FOUND)
      if(FFmpeg_swresample_FOUND)
        set(HAVE_SWRESAMPLE 1)
        target_link_libraries(${plugin_TARGET} PRIVATE FFmpeg::swresample)
      elseif(FFmpeg_avresample_FOUND)
        set(HAVE_AVRESAMPLE 1)
        target_link_libraries(${plugin_TARGET} PRIVATE FFmpeg::avresample)
      else()
        include(CheckFunctionExists)
        set(_CMAKE_REQUIRED_LIBRARIES_TMP ${CMAKE_REQUIRED_LIBRARIES})
        set(CMAKE_REQUIRED_LIBRARIES FFmpeg::avformat FFmpeg::avcodec FFmpeg::avutil)
        check_function_exists(av_audio_convert HAVE_AV_AUDIO_CONVERT)
        set(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES_TMP})
      endif()
    endif()

    target_link_libraries(${plugin_TARGET} PRIVATE FFmpeg::avformat FFmpeg::avcodec FFmpeg::avutil)
    if(WIN32 OR APPLE)
      target_link_libraries(${plugin_TARGET} PRIVATE ${ZLIB_LIBRARIES})
    endif()
  else()
    target_link_libraries(${plugin_TARGET} PRIVATE Qt5::Multimedia)
  endif()

  if(APPLE)
    find_library(ACCELERATE_LIBRARIES Accelerate)
    target_link_libraries(${plugin_TARGET} PRIVATE ${ACCELERATE_LIBRARIES})
  endif()

  configure_file(acoustidconfig.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/acoustidconfig.h)

  if(APPLE AND CMAKE_SYSTEM_PROCESSOR STREQUAL "i386")
    # To suppress linker error
    # ld: illegal text-relocation to non_lazy_ptr in ../libavformat.a
    # (allformats.o) from _av_register_all in ../libavformat.a(allformats.o)
    # for architecture i386
    # ld: illegal text-relocation to _cpy8 in /usr/local/lib/libswresample.a
    # (audioconvert.o) from _swri_audio_convert_alloc in
    # /usr/local/lib/libswresample.a(audioconvert.o) for architecture i386
    set_target_properties(${plugin_TARGET} PROPERTIES LINK_FLAGS -Wl,-read_only_relocs,suppress)
  endif()

  if(LINUX_SELF_CONTAINED)
    # To avoid linker error
    # relocation R_X86_64_PC32 against symbol `ff_pw_9' can not be used when
    # making a shared object; recompile with -fPIC
    # see http://www.ffmpeg.org/platform.html#Advanced-linking-configuration
    set_target_properties(${plugin_TARGET} PROPERTIES LINK_FLAGS -Wl,-Bsymbolic)
  endif()

  INSTALL_KID3_PLUGIN(${plugin_TARGET} ${plugin_NAME})
endif()

=== src/plugins/kid3qml/CMakeLists.txt ===
set(plugin_NAME Kid3Qml)

string(TOLOWER ${plugin_NAME} plugin_TARGET)

if(APPLE)
  # The extension must be dylib, not so.
  add_library(${plugin_TARGET} SHARED kid3qmlplugin.cpp)
else()
  add_library(${plugin_TARGET} MODULE kid3qmlplugin.cpp)
endif()

qt5_wrap_cpp(plugin_GEN_MOC_SRCS
  kid3qmlplugin.h
  scriptutils.h
  configobjects.h
  checkablelistmodel.h
  TARGET ${plugin_TARGET}
)

target_sources(${plugin_TARGET} PRIVATE
  qmlimageprovider.cpp
  scriptutils.cpp
  configobjects.cpp
  checkablelistmodel.cpp
  ${plugin_GEN_MOC_SRCS}
  Kid3Script.qml
  "${kid3_plugins_BINARY_DIR}/imports/Kid3/Kid3Script.qml"
)

target_link_libraries(${plugin_TARGET} kid3-core kid3-gui Qt5::Quick Kid3Plugin)

if(NOT HAVE_QMLDIR_IN_QRC)
  install(TARGETS ${plugin_TARGET}
    LIBRARY DESTINATION ${WITH_PLUGINSDIR}/imports/Kid3
    RUNTIME DESTINATION ${WITH_PLUGINSDIR}/imports/Kid3)
  set_target_properties(
    ${plugin_TARGET} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${kid3_plugins_BINARY_DIR}/imports/Kid3
    LIBRARY_OUTPUT_DIRECTORY ${kid3_plugins_BINARY_DIR}/imports/Kid3
  )
else()
  install(TARGETS ${plugin_TARGET}
    LIBRARY DESTINATION ${WITH_BINDIR}
    RUNTIME DESTINATION ${WITH_BINDIR})
  file(MAKE_DIRECTORY "${kid3_plugins_BINARY_DIR}/imports/Kid3")
endif()
if(ANDROID)
  # Fix "-soname: must take a non-empty argument" error with CMake >= 3.2.
  # http://stackoverflow.com/questions/26841603/arm-linux-androideabi-bin-ld-fatal-error-soname-must-take-a-non-empty-argume
  string(REPLACE "<CMAKE_SHARED_LIBRARY_SONAME_CXX_FLAG><TARGET_SONAME>" ""
         CMAKE_CXX_CREATE_SHARED_MODULE "${CMAKE_CXX_CREATE_SHARED_MODULE}")
endif()
if(LINUX_SELF_CONTAINED)
  # Just to keep CMake quiet, not needed at run time.
  set_target_properties(
    ${plugin_TARGET} PROPERTIES INSTALL_RPATH "\$ORIGIN/../../..")
endif()

if(WIN32)
  set(_qmldirPluginName libkid3qml)
else()
  set(_qmldirPluginName kid3qml)
endif()
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmldir.in
               "${kid3_plugins_BINARY_DIR}/imports/Kid3/qmldir"
               @ONLY)
add_custom_command(OUTPUT "${kid3_plugins_BINARY_DIR}/imports/Kid3/Kid3Script.qml"
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/Kid3Script.qml "${kid3_plugins_BINARY_DIR}/imports/Kid3/"
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/Kid3Script.qml
  WORKING_DIRECTORY "${kid3_plugins_BINARY_DIR}/imports/Kid3"
)

install(FILES "${kid3_plugins_BINARY_DIR}/imports/Kid3/qmldir"
              "${kid3_plugins_BINARY_DIR}/imports/Kid3/Kid3Script.qml"
        DESTINATION ${WITH_PLUGINSDIR}/imports/Kid3)
if(NOT WIN32 AND NOT ANDROID AND NOT(CMAKE_CXX_COMPILER MATCHES "/osxcross/"))
  get_target_property(_qmakeLocation Qt5::qmake LOCATION)
  execute_process(COMMAND "${_qmakeLocation}" -query QT_INSTALL_BINS
    OUTPUT_VARIABLE _qtInstallBins OUTPUT_STRIP_TRAILING_WHITESPACE)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/runqmlplugindump.cmake.in
                 ${CMAKE_CURRENT_BINARY_DIR}/runqmlplugindump.cmake
                 @ONLY)
  add_custom_command(OUTPUT "${kid3_plugins_BINARY_DIR}/imports/Kid3/plugins.qmltypes"
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/runqmlplugindump.cmake
    DEPENDS ${plugin_TARGET}
    WORKING_DIRECTORY "${kid3_plugins_BINARY_DIR}/imports/Kid3")
  add_custom_target(plugins_qmltypes ALL
    DEPENDS "${kid3_plugins_BINARY_DIR}/imports/Kid3/plugins.qmltypes")
  add_dependencies(plugins_qmltypes ${plugin_TARGET})

  install(FILES "${kid3_plugins_BINARY_DIR}/imports/Kid3/plugins.qmltypes"
          DESTINATION ${WITH_PLUGINSDIR}/imports/Kid3 OPTIONAL)
endif()

if(WIN32 OR APPLE OR LINUX_SELF_CONTAINED)
  # Install essential QML modules.
  get_target_property(QT_QML_DIR Qt5::qmake LOCATION)
  get_filename_component(QT_QML_DIR ${QT_QML_DIR} PATH)
  get_filename_component(QT_QML_DIR ${QT_QML_DIR} PATH)
  set(QT_QML_DIR ${QT_QML_DIR}/qml)
  install(DIRECTORY "${QT_QML_DIR}/QtQuick.2"
    DESTINATION "${WITH_PLUGINSDIR}/imports"
    FILES_MATCHING PATTERN "*plugin${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "qmldir"
                   PATTERN "*.dSYM" EXCLUDE)
  install(DIRECTORY "${QT_QML_DIR}/QtQuick/Layouts"
    DESTINATION "${WITH_PLUGINSDIR}/imports/QtQuick"
    FILES_MATCHING PATTERN "*plugin${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "qmldir"
                   PATTERN "*.dSYM" EXCLUDE)
endif()

=== debian/changelog ===
kid3 (3.8.2-2) unstable; urgency=medium

  * Add dependency on libqt5multimedia5-plugins for the kid3-qt package.
    Closes: #951618
  * Revert: Remove unused manpages from kid3-core package.
    Closes: #951343

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 05 Mar 2020 12:30:48 +0100

kid3 (3.8.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.0.
  * Adjust source lintian-overrides.
  * Remove unused manpages from kid3-core package.
  * Remove build path from plugins.qmltypes.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 23 Jan 2020 15:36:00 +0100

kid3 (3.8.1-1) unstable; urgency=medium

  * New upstream release.
  * Use the new debhelper-compat notation, and drop the d/compat file.
  * Bump Standards-Version to 4.4.1.
  * Add Rules-Requires-Root: no.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 24 Dec 2019 10:00:57 +0100

kid3 (3.8.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump debian/compat to level 12.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 28 Aug 2019 15:09:21 +0200

=== debian/control ===
Source: kid3
Section: kde
Priority: optional
Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Build-Depends: debhelper-compat (= 12),
 extra-cmake-modules,
 libkf5kio-dev,
 libkf5doctools-dev,
 qtmultimedia5-dev,
 qtdeclarative5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtdeclarative5-dev-tools,
 qml-module-qtquick2,
 cmake,
 libid3-3.8.3-dev,
 libflac++-dev,
 libvorbis-dev,
 libtag1-dev,
 libchromaprint-dev,
 libavformat-dev,
 libavcodec-dev,
 docbook-xsl,
 pkg-config,
 libreadline-dev,
 xsltproc
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://kid3.sourceforge.net/

Package: kid3-core
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Audio tag editor core libraries and data
 With Kid3, an ID3 tag editor for KDE you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package contains common libraries and data used by both kid3 and kid3-qt.

Package: kid3
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: KDE audio tag editor
 With Kid3, an ID3 tag editor for KDE you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package uses KDE libraries, if you do not use KDE you should use kid3-qt.

Package: kid3-qt
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version}),
 libqt5multimedia5-plugins
Description: Audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package does not use KDE libraries, if you use KDE you should use kid3.

Package: kid3-cli
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Command line audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package contains a command line interface for Kid3, for a GUI you can
 use kid3-qt or kid3.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_CMAKE_PREFIX = /usr
DEB_CONFIG_INSTALL_DIR = $(DEB_CMAKE_PREFIX)/share/kde4/config
DEB_HTML_INSTALL_DIR = $(DEB_CMAKE_PREFIX)/share/doc/kde/HTML
BASE_CMAKE_DEFS = -DKDE_INSTALL_BINDIR=$(DEB_CMAKE_PREFIX)/bin -Wno-dev -DWITH_FFMPEG=ON -DCMAKE_BUILD_TYPE=RelWithDebInfo

%:
	dh $@ --builddirectory=kid3-build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DSYSCONF_INSTALL_DIR=/etc \
		-DCMAKE_INSTALL_PREFIX=$(DEB_CMAKE_PREFIX) \
		$(BASE_CMAKE_DEFS) \
		-DLIB_INSTALL_DIR=$(DEB_CMAKE_PREFIX)/lib/kid3 \
		-DCMAKE_C_FLAGS="$(CFLAGS)" \
		-DCMAKE_CXX_FLAGS="$(CXXFLAGS)"

override_dh_auto_build:
	dh_auto_build
	cp kid3-build/doc/en/kid3.1 kid3-build/doc/en/kid3-core.1
	cp kid3-build/doc/de/kid3.1 kid3-build/doc/de/kid3-core.de.1

override_dh_auto_install:
	dh_auto_install

override_dh_install:
	dh_install
	sed '/This file was auto-generated by:/,+1 d' -i \
		$(CURDIR)/debian/kid3-core/usr/lib/kid3/plugins/imports/Kid3/plugins.qmltypes

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

override_dh_compress:
	dh_compress --exclude=.docbook

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
http://sf.net/kid3/kid3-([\d.]*)\.tar\.gz
